%% BRING IN TIME SERIES FROM MEASSURMENTS
%Bring the .mat-file and load it into the workspace

%D is the data matrix from measurements, potentially containing the
%timestamps in the last column
data=D;
%% LOWPASS AND RESAMPLE
fs_org=1652;
fs_new=59;

dataRS=resample(data,fs_new,fs_org);    %resample function with builtin anti-aliasing filter
dim=min(size(dataRS));
%% PERFORM COV-SSI
blockrows=70;%"i"
order=2:2:200;%"n"

[lambda,Phi,order] = omassi(dataRS(1:25000,:),fs_new,'order',order,'blockrows',blockrows);
%labda: eigenvalues of each State Matrix
%Phi: One representation of each of the complex conjugated mode shapes for
%each system order
%order: System orders to which the eigenvalues and eigenvectors belong
%% STABILIZATION DIAGRAM
mode='both';

%Extract frequencies and damping from the eigenvalues
for o=1:length(order)
    warray{o} = abs(lambda{o})/(2*pi);%In terms of Hz
    xiarray{o} = -real(lambda{o})./abs(lambda{o});
end

stabPlot(warray,xiarray,order,'plot',mode)
xlim([0,10])
pos=get(gcf,'Position');
set(gcf,'Position',[pos(1:2) 1000 200])