clear all
close all
clc

Fs=770;
dt=1/Fs;
tmax=7200;
vari=0.05;% prosentvis variasjon av tidssteg

noiseA=10;

%Effect parameters

%Drop in dt
dt_dropMean=0.0003;%300 sec
dt_dropMin=0.0001;

%Time spent on saving data to tdms
dt_savingMin=0.01;%10ms

% Jittered time axis and following frequency axis
T=zeros(1,Fs*tmax); dt_all=T; fs_all=T;
for i=2:length(T)
    if rem(i,20)~=0 && rem(i,1000)~=0%Variation of regular dt
        T(i)=T(i-1)+dt+dt*vari*(-1+2*rand);
    elseif rem(i,20)==0 && rem(i,1000)~=0%Drop in dt
        T(i)=T(i-1)+dt_dropMin*(1+4*rand);
    elseif rem(i,1000)==0%Increase in dt due to saving
        T(i)=T(i-1)+dt_savingMin*(1+0.4*rand);
    end
    dt_all(i-1)=T(i)-T(i-1);
    fs_all(i-1)=1/dt_all(i-1);    
end

f_all=zeros(1,length(fs_all));
f_all(1)=-mean(fs_all)/2; f_all(end)=-f_all(1);

for i=2:length(f_all)-1
    f_all(i)=f_all(i-1)+fs_all(i)/(length(fs_all)-1);
end

sin_all=sin(2*pi*T)+noiseA*rand(1,length(T));

% Even time axis and following frequency axis
fs=770;
dT=tmax/(tmax*fs-1);
t=0:dT:tmax;%dt*length(T)-dt;
sin_even=sin(2*pi*t)+noiseA*rand(1,length(t));

fs=1/dT;
dF=fs/(length(t)-1);
F=(-fs/2):dF:(fs/2);

figure
hold on
plot(T,sin_all)
plot(t,sin_even)

% APSD, uneven signal
g=fftshift(fft(sin_all));
APSD_all=g.*conj(g);

% APSD, even signal
G=fftshift(fft(sin_even));
APSD_even=G.*conj(G);

%% Plot APSD of even and jittered signals
figure
semilogy(F,APSD_all)
hold
semilogy(F,APSD_even)
hold
xlim([0,1.5])
legend('Unevenly sampled PSD','Evenly sampled PSD')

matName='APSD_all';
path='D:\Skolearbeid\Masteroppgave\MatLab\SSIresults\';
Path=strcat(path,matName);
data=sin_all';
save(Path,'APSD_all','f_all','data','T')