clear all
close all
clc

Fs=770;
dt=1/Fs;
tmax=7200;
noiseA=0;

t=0:dt:tmax-dt;%Even time axis

% Time axis with random drops
dt_dropMean=0.0003;%300 sec
dt_dropVar=0.0002;
t_drop=zeros(1,Fs*tmax);
dt_dropped=t_drop; dt_dropped(1)=dt;
fs_uneven=t_drop; fs_uneven(1)=Fs;


for i=2:Fs*tmax
    if rem(i,20)~=0
        t_drop(i)=t_drop(i-1)+dt;
    elseif rem(i,20)==0
        t_drop(i)=t_drop(i-1)+dt_dropMean+dt_dropVar*(100*rand);
    end
    dt_dropped(i)=t_drop(i)-t_drop(i-1);
    fs_uneven(i)=1/dt_dropped(i);
end

figure
plot(dt_dropped(1:10000))

sin_even=sin(2*pi*t)+noiseA*rand(1,length(t));
sin_drop=sin(2*pi*t_drop)+noiseA*rand(1,length(t_drop));

figure
hold on
plot(t,sin_even)
plot(t,sin_drop)
hold off

%Power spectrum of unevenly sampled signal
f_uneven=zeros(1,length(fs_uneven));
f_uneven(1)=-mean(fs_uneven)/2;
f_uneven(end)=-f_uneven(1);

for i=2:length(fs_uneven)-1
    f_uneven(i)=f_uneven(i-1)+...
        fs_uneven(i)/(length(fs_uneven)-1);
end

f_mean=1/mean(dt_dropped);
f_drop=-f_mean/2:f_mean/(length(fs_uneven)-1):f_mean/2;
g=fftshift(fft(sin_drop));
APSD_drop=g.*conj(g);

%Power spectrum of evenly sampled signal
df_even=Fs/(length(t)-1);
f_even=-Fs/2:df_even:Fs/2;
G=fftshift(fft(sin_even));
APSD_even=G.*conj(G);

%Plot both power spectrum together
figure
semilogy(f_even,APSD_even)
hold
semilogy(f_drop,APSD_drop)
hold
xlim([0.9,1.5])
legend('Signal with even \delta t','Signal with dropped \delta t')