clear all 
%close all 
clc

Fs=770;
dt=1/Fs;
tmax=7200;
t=0:dt:tmax-dt;
noiseA=0;

t_drop=zeros(1,Fs*tmax); 
f_drop=t_drop;

dt_drop=zeros(1,length(t_drop)-1);
fs_drop=dt_drop;

min_drop=0.0001;
max_var=0.0004;
for i=2:length(t_drop)
    if rem(i,20)~=0
        t_drop(i)=t_drop(i-1)+dt;
    elseif rem(i,20)==0
        t_drop(i)=t_drop(i-1)+(min_drop+max_var*rand);
    end
    dt_drop(i-1)=t_drop(i)-t_drop(i-1);
    fs_drop(i-1)=1/dt_drop(i-1);
end

% Create irregular frequency axis of signal with time jumps
% f_jump(1)=-mean(fs_jump)/2;
% f_jump(end)=-f_jump(1);
% 
% for i=2:length(f_jump)-1
%     f_jump(i)=f_jump(i-1)+fs_jump(i)/(length(fs_jump)-1);    
% end
% clear f_jump

%Time series
sin_even=sin(2*pi*t)+noiseA*rand(1,length(t));
sin_drop=sin(2*pi*t_drop)+noiseA*rand(1,length(t_drop));

% Even APSD
df_even=Fs/(length(t)-1);
f_even=-Fs/2:df_even:Fs/2;
G=fftshift(fft(sin_even));
APSD_even=G.*conj(G);

% APSD with regular frequency axis
f_mean=length(t_drop)/max(t_drop);%1/mean(dt_drop);
f_drop=-f_mean/2:f_mean/(length(t)-1):f_mean/2;

clear G
G=fftshift(fft(sin_drop));
APSD_jump=G.*conj(G);

%Plot both power spectrum together
figure
semilogy(f_even,APSD_even)
hold
semilogy(f_drop,APSD_jump)
hold
xlim([0,1.5])
