clear all
close all
clc

Fs=760;
dt=1/Fs;
tmax=7200;
vari=0.15;% prosentvis variasjon av tidssteg
noiseA=10;

% Varierende tidsakse
T=0:dt+dt*vari*(-1+2*rand(1)):tmax;
a0=sin(2*pi*T)+noiseA*rand(1,length(T));

% Varierende dt og frekvens
dt_var=zeros(1,length(T)-1); fs_var=dt_var;
for i=1:length(T)-1
    dt_var(i)=T(i+1)-T(i);
    fs_var(i)=1/dt_var(i);
end



% Akselerasjoner med jevn tidsaske
dT=tmax/(length(T)-1);
t=0:dT:tmax;%dt*length(T)-dt;
a=sin(2*pi*t)+noiseA*rand(1,length(t));%interp1(T,a0,t,'spline');

figure
hold on
plot(T,a0)
plot(t,a)

% APSD, uneven signal

g=fft(a0(1:end-1));
gg=fftshift(g);
APSD_uneven=gg.*conj(gg);

G=fft(a(1:end-1));
GG=fftshift(G);
APSD_even=GG.*conj(GG);

fs=1/dT;
dF=fs/(length(APSD_even)-1);
F=(-fs/2):dF:(fs/2);

figure
semilogy(F,APSD_uneven)
hold
semilogy(F,APSD_even)
hold
xlim([0,5])
legend('Unevenly sampled PSD','Evenly sampled PSD')
