clear all 
close all 
clc

Fs=770;
dt=1/Fs;
tmax=7200;
t=0:dt:tmax-dt;
noiseA=50;

t_jump=zeros(1,Fs*tmax); 
f_jump=t_jump;

dt_jump=zeros(1,length(t_jump)-1);
fs_jump=dt_jump;

min_wait=0.009;
max_wait=0.005;
for i=2:length(t_jump)
    if rem(i,1000)~=0
        t_jump(i)=t_jump(i-1)+dt;
    elseif rem(i,1000)==0
        % Random jump of 10 to 14 ms
        t_jump(i)=t_jump(i-1)+(min_wait+max_wait*rand);
    end
    dt_jump(i-1)=t_jump(i)-t_jump(i-1);
    fs_jump(i-1)=1/dt_jump(i-1);
end

% Create irregular frequency axis of signal with time jumps
% f_jump(1)=-mean(fs_jump)/2;
% f_jump(end)=-f_jump(1);
% 
% for i=2:length(f_jump)-1
%     f_jump(i)=f_jump(i-1)+fs_jump(i)/(length(fs_jump)-1);    
% end
% clear f_jump

%Time series
sin_even=sin(2*pi*t)+noiseA*rand(1,length(t));
sin_jump=sin(2*pi*t_jump)+noiseA*rand(1,length(t_jump));

% Even APSD
df_even=Fs/(length(t)-1);
f_even=-Fs/2:df_even:Fs/2;
G=fftshift(fft(sin_even));
APSD_even=G.*conj(G);

% APSD with regular frequency axis
f_mean=1/mean(dt_jump);
f_jump=-f_mean/2:f_mean/(length(t)-1):f_mean/2;

clear G
G=fftshift(fft(sin_jump));
APSD_jump=G.*conj(G);

%Plot both power spectrum together
figure
semilogy(f_even,APSD_even)
hold
semilogy(f_jump,APSD_jump)
hold
legend('Evenly sampled','180 to 184 ms Saving Time Included')
xlim([0,1.5])
