clear all
close all
clc

Fs=770;
dt=1/Fs;
tmax=7200;
vari=0.95;% Percentage variation of time step
noiseA=50;% Noise amplitude relative to 1Hz-component

% Jittered time axis and following frequency axis
t_var=zeros(1,Fs*tmax); dt_var=t_var; fs_var=t_var;
for i=2:length(t_var)
    t_var(i)=t_var(i-1)+dt+dt*vari*(-1+2*rand);
    dt_var(i-1)=t_var(i)-t_var(i-1);
    fs_var(i-1)=1/dt_var(i-1);
end

% Create non-regular frequency axis
% f_var=zeros(1,length(fs_var));
% f_var(1)=-mean(fs_var)/2; f_var(end)=-f_var(1);
% for i=2:length(f_var)-1
%     f_var(i)=f_var(i-1)+fs_var(i)/(length(fs_var)-1);
% end

sin_var=sin(2*pi*t_var)+noiseA*rand(1,length(t_var));

% Even time axis and signal
t=0:dt:tmax;%dt*length(T)-dt;
sin_even=sin(2*pi*t)+noiseA*rand(1,length(t));

% figure
% hold on
% plot(t_var,sin_var)
% plot(t,sin_even)

% APSD, uneven signal
f_mean=1/mean(dt_var);
df_var=f_mean/(length(t)-2);
f_var=-f_mean/2:df_var:f_mean/2;

g=fftshift(fft(sin_var));
APSD_var=g.*conj(g);

% APSD, even signal
dF=Fs/(length(t)-1);
F=(-Fs/2):dF:(Fs/2);

G=fftshift(fft(sin_even));
APSD_even=G.*conj(G);
%% Plot APSD of even and jittered signals
figure
semilogy(f_var,APSD_var)
hold
semilogy(F,APSD_even)
hold
xlim([0,1.5])
legend(sprintf('Unevenly sampled PSD, %d %s variation of %s t',...
    100*vari,'%','\delta'),'Evenly sampled PSD')

% path='D:\D:\Skolearbeid\Masteroppgave\MatLab\Time Series Verification\';
% Path=strcat(path,matName);
% 
% save(Path,'D','data','series')