%% Import TDMS to .mat
clear all
close all
clc

%Insert file name without .tdms-ending
series='LM';

A=simpleConvertTDMS(strcat(series,'.tdms'));
load(strcat(series,'.mat'));

%Channels are automatically named Untitled in LabVIEW, and MatLab adds
%ending to each of the channels.
channels=[UntitledUntitled,UntitledUntitled1,UntitledUntitled2...
    ,UntitledUntitled3,UntitledUntitled4];%,UntitledUntitled5...
    %,UntitledUntitled6,UntitledUntitled7,UntitledUntitled8];

C=struct2cell(channels);

D=zeros(length(C{1}),length(channels));
chPosition=1:3:3*(length(channels)-1)+1;
%% Convert Voltages to m/s^2, place every channel within the desired
% coordinate system. 

%Volt to acceleration [m/s^2]
VtoAcc=4.905*[1,1,1,1];
%VtoAcc=4.905*[1,1,20,20,1,1,20,20,1/4.905];

%Coordinate systems, last entry 1 for time column!
csyst=[-1,1,1,-1];
%csyst=[-1,1,1,-1,-1,1,1,-1];
for i=1:min(size(D))-1
    D(:,i)=csyst(i).*VtoAcc(i).*C{chPosition(i)};
end

%Simple detrend
for i=1:length(VtoAcc)
    D(:,i)=D(:,i)-mean(D(:,i));
end

%Extract acceleration data from D
data=D(:,1:end-1);