clear l f xi ind
%Set requirements to frequency range and damping range in stabilization
%digram to extract natural frequencies
fmin=3;
fmax=3.03;

ximin=0.01;
ximax=0.03;

%System index=System Order/2
%Set maximum and minimum system idices to be scanned
min_index=20;
max_index=164;

ind=[];
f=[];
xi=[];
for i=min_index:max_index
    allFreqs=warray{i};
    relFreqPos=find(and(allFreqs>fmin,allFreqs<fmax));
    dampReq=find(and(xiarray{i}(relFreqPos)<ximax,xiarray{i}(relFreqPos)>ximin));
    okFreqPos=relFreqPos(dampReq);   
    l(i)=length(okFreqPos);%Number of frequencies fulfilling requirement
    if length(l(i))>0
        ind=[ind;i*ones(l(i),1)];  
        xi=[xi;xiarray{i}(okFreqPos)];
        f=[f;warray{i}(okFreqPos)];
    else
        ind=ind;
    end 
end

%% Plot damping fulfilling the requirements
figure
scatter(2*ind,100*xi)
ylim([0,ceil(1.5*fmax)])
xlabel('Order')
ylabel('\xi [%]')